/**
* @par Copyright (C): 2010-2019, Shenzhen Yahboom Tech
* @file         Whistle.ino
* @author       chengengyue
* @version      V1.0
* @date         2019.10.08
* @brief        鸣笛
* @details
* @par History  见如下说明
*/
#define BUZZER 10    // 定义蜂鸣器引脚
#define KEY_PIN 8    // 定义功能按键引脚
#define LED_PIN 5    // 定义LED灯（D9）引脚


// 按键状态
bool button_press = false;

/**
* Function       keyscan
* @author        chengengyue
* @date          2019.10.08
* @brief         按键扫描
* @param[in1]    void
* @retval        void
* @par History   无
*/
void keyscan()
{
  int val;
  val = digitalRead(KEY_PIN); // 读取数字8口电平值赋给val
  if (val == LOW)             // 当按键被按下时
  {
    delay(10);                  // 延时消抖
    val = digitalRead(KEY_PIN); // 再次读取按键状态
    while (val == LOW)
    {
      val = digitalRead(KEY_PIN); // 第三次读取按键状态
      if (val == HIGH)            // 判断按键是否松开，松开才执行
      {
        button_press = !button_press;
        return;
      }
    }
  }
}

/*
* Function       whistle
* @author        chengengyue
* @date          2019.10.08
* @brief         鸣笛
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   无
*/
void whistle()
{
  for (int i = 0; i < 100; i++)
  {
    digitalWrite(BUZZER, HIGH); //发声音
    delay(3);                   //延时
    digitalWrite(BUZZER, LOW);  //不发声音
    delay(1);                   //延时
  }
}

void setup() {
  // put your setup code here, to run once:
  pinMode(KEY_PIN, INPUT_PULLUP);// 设置按键引脚为上拉输入模式
  pinMode(LED_PIN, OUTPUT);      // 设置LED引脚为输出模式
  pinMode(BUZZER, OUTPUT);       // 设置蜂鸣器引脚为输出模式
}

void loop() {
  // put your main code here, to run repeatedly:
  // 按键扫描
  keyscan();
  if (button_press)
  {
    whistle();             // 鸣笛
    button_press = false;  // 设置按键状态为false
  }
}
